<?php
/*
Plugin Name: TipJoy TipThis
Plugin URI: http://www.KnightKnetwork.com/TipThis/
Version: 0.9.5
Author: <a href="http://www.KnightKnetwork.com/">David Knight</a>
Description: TipThis allows you to earn tips with <a href="http://www.tipjoy.com">TipJoy</a> Tip This buttons.
*/

/*  Copyright 2008 David Knight  (email : David@KnightKnetwork.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
$tipThisVersion = "0.9.5";
$tipThisPluginHome = "http://knightknetwork.com/2008/02/15/tipjoy-tipthis-wordpress-plugin/";
//admin panel
$tipthisAdminOptionsName = "TipThisAdminOptions";
$tipThisWhiteTextString = "&bg=dark";

//Returns an array of admin options
function getTipThisAdminOptions() {
	$TipThisAdminOptions = array(
	                            'tip_everything' => 'false',
								'tip_single_post' => 'true',
								'tip_page' => 'true',
								'tip_text_color' => 'black',
								'tip_sidebar_title' => '',
								'tipThis_User_ID' => ''
								);
	$devOptions = get_option(TipThisAdminOptionsName);
	if (!empty($devOptions)) {
		foreach ($devOptions as $key => $option)
			$TipThisAdminOptions[$key] = $option;
	}
	update_option(tipThisAdminOptionsName, $TipThisAdminOptions);
	return $TipThisAdminOptions;
}
// init options on plugin activation
function TipThisInit() {
	getTipThisAdminOptions();
}

//Prints out the admin page
function printTipThisAdminPage() {
	global $tipThisVersion;
	global $tipThisPluginHome;
	$devOptions = getTipThisAdminOptions();
	if (isset($_POST['update_tipJoyTipThisSettings'])) {
	
		if (isset($_POST['tipThisEverything'])) {
			$devOptions['tip_everything'] = $_POST['tipThisEverything'];
		}
		if (isset($_POST['tipThisSinglePost'])) {
			$devOptions['tip_single_post'] = $_POST['tipThisSinglePost'];
		}
		if (isset($_POST['tipThisPage'])) {
			$devOptions['tip_page'] = $_POST['tipThisPage'];
		}
		if (isset($_POST['tipTextColor'])) {
			$devOptions['tip_text_color'] = $_POST['tipTextColor'];
		}
		if (isset($_POST['tipThisUserID'])) {
			$devOptions['tipThis_User_ID'] = apply_filters('content_save_pre', $_POST['tipThisUserID']);
		}
		
		update_option(tipThisAdminOptionsName, $devOptions);
		?>
		<div class="updated"><p><strong><?php _e("Settings Updated.","TipJoy TipThis");?></strong></p></div>
		<?php
	} ?>
	<div class=wrap>
	<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
		<h2>TipThis</h2>
		<h3>Tips for <?php echo get_settings('home'); ?></h3>
		<iframe  src="http://tipjoy.com/stats?url=<?php echo get_settings('home'); ?>" scrolling="no" height="120px" width="268px"  frameborder="0" marginwidth="0" marginheight="0" hspace="0" vspace="0" allowtransparency="true" ></iframe>
		<h3>TipThis User ID:</h3>
		<textarea name="tipThisUserID" style="width: 80%; height: 25px;"><?php _e(apply_filters('format_to_edit',$devOptions['tipThis_User_ID']),'TipJoy TipThis') ?></textarea>
		<h3>Place a Tip This button on EVERYTHING? (Yes overrides other settings)</h3>
		<p>	
			<label for="tipThisEverything_yes"><input type="radio" id="tipThisEverything_yes" name="tipThisEverything" value="true" <?php if ($devOptions['tip_everything'] == "true") { _e('checked="checked"', "TipJoy TipThis"); }?>/> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
			<label for="tipThisEverything_no"><input type="radio" id="tipThisEverything_no" name="tipThisEverything" value="false" <?php if ($devOptions['tip_everything'] == "false") { _e('checked="checked"', "TipJoy TipThis"); }?>/> No</label>
		</p>
		<h3>Place a Tip This button on single posts?</h3>
		<p>
			<label for="tipThisSingle_yes"><input type="radio" id="tipThisSingle_yes" name="tipThisSinglePost" value="true" <?php if ($devOptions['tip_single_post'] == "true") { _e('checked="checked"', "TipJoy TipThis"); }?>/> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
			<label for="tipThisSingle_no"><input type="radio" id="tipThisSingle_no" name="tipThisSinglePost" value="false" <?php if ($devOptions['tip_single_post'] == "false") { _e('checked="checked"', "TipJoy TipThis"); }?>/> No</label>
		</p>
		<h3>Place a Tip This button on Wordpress "Pages"?</h3>
		<p>
			<label for="tipThisPage_yes"><input type="radio" id="tipThisPage_yes" name="tipThisPage" value="true" <?php if ($devOptions['tip_page'] == "true") { _e('checked="checked"', "TipJoy TipThis"); }?>/> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
			<label for="tipThisPage_no"><input type="radio" id="tipThisPage_no" name="tipThisPage" value="false" <?php if ($devOptions['tip_page'] == "false") { _e('checked="checked"', "TipJoy TipThis"); }?>/> No</label>
		</p>
		<h3>What color should the descriptive text be?</h3>
		<p>
			<label for="tipTextColor_black"><input type="radio" id="tipTextColor_black" name="tipTextColor" value="black" <?php if ($devOptions['tip_text_color'] == "black") { _e('checked="checked"', "TipJoy TipThis"); }?>/> Black</label>&nbsp;&nbsp;&nbsp;&nbsp;
			<label for="tipTextColor_white"><input type="radio" id="tipTextColor_white" name="tipTextColor" value="white" <?php if ($devOptions['tip_text_color'] == "white") { _e('checked="checked"', "TipJoy TipThis"); }?>/> White</label><br />
			Black is better for light backgrounds and White for dark backgrounds.
		</p>
		<h3>Love this plugin?  Leave a tip to support it:</h3>
		<p>
			<iframe src="http://tipjoy.com/bannerButton/?type=standardWide&targetUser=KnightKnetwork&targetUrl=http://knightknetwork.com/2008/02/15/tipjoy-tipthis-wordpress-plugin/" style="padding:0em;" height="80px" width="720px"  marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no" allowtransparency="true" ></iframe><br />
			This is version <?php echo $tipThisVersion ?>, check the <a href ="<?php echo $tipThisPluginHome?>">TipJoy TipThis Home</a> for updates
		</p>
		<div class="submit">
			<input type="submit" name="update_tipJoyTipThisSettings" value="<?php _e('Update Settings', 'TipJoy TipThis') ?>" />
		</div>
	</form>
	</div>
	<?php
}	//end printTipThisAdminPage

function TipThis_ap() {
	if (function_exists('add_options_page')) {
		add_options_page('TipJoy TipThis', 'TipJoy TipThis', 9,
		basename(__FILE__), 'printTipThisAdminPage');
	}
}
//--- End of Admin Panel Code

	
// Add TipJoy header information 
function addTipJoyHeader(){
	$devOptions = getTipThisAdminOptions();
	echo '<!--tipjoy:'. $devOptions['tipThis_User_ID'] .'--> ';
}


// Build and display the Tip This button
function addTipThisButton($content) {
	global $tipThisPluginHome;
	global $tipThisWhiteTextString;
	$devOptions = getTipThisAdminOptions();
	$postTitle = the_title('','',FALSE);
	if ($devOptions['tip_text_color'] == "white") {$postTitle .= $tipThisWhiteTextString;}
	// build the TipJoy JavaScript 
	$tipJoyScript = '<script language="javascript" src="http://tipjoy.com/buttonGen?targetUser='
		. $devOptions['tipThis_User_ID'] 
		. '&targetUrl='
		. get_permalink() 
		. '&title=' 
		. $postTitle
		. '" scrolling="no" frameborder="0" marginwidth="0" marginheight="0" hspace="0" vspace="0" allowtransparency="true" ></script>'
		. '<a href="'. $tipThisPluginHome .'"> [?]</a><br />';
	switch (TRUE){
		case ($devOptions['tip_everything'] == 'true'): break;
		case (is_single() && $devOptions['tip_single_post'] == 'true'): break;
		case (is_page() && $devOptions['tip_page'] == 'true'): break;
		default: 
			return $content;
	}
	return $content . $tipJoyScript;  // add to the end of the content
}
function tipjoy_sidebar_init(){
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
        return;

	function tipjoy_sidebar_banner($args){
		extract($args);
		
		$tipJoyOptions = getTipThisAdminOptions();
        $title = empty($tipJoyOptions['tip_sidebar_title']) ? 'none' : $tipJoyOptions['tip_sidebar_title'];
        $tipjoyID = empty($tipJoyOptions['tipThis_User_ID']) ? '' : $tipJoyOptions['tipThis_User_ID']; 
		
		echo $before_widget;
		if ($title != 'none'){
			echo $before_title
		                . $title
		                . $after_title;
		}
		?>
		<iframe src="http://tipjoy.com/bannerButton/?type=standardShort&targetUser=<?php echo $tipjoyID ?>&targetUrl=<?php bloginfo('url'); ?>" 
				style="padding:0em;" 
				height="60px" 
				width="234px"  
				marginwidth="0" 
				marginheight="0" 
				hspace="0" 
				vspace="0" 
				frameborder="0"
				scrolling="no" 
				allowtransparency="true" >
		</iframe>
		<?php echo $after_widget;
	} // end  tipjoy_sidebar_banner
	
	function tipjoy_sidebar_control() {

		$options = getTipThisAdminOptions();

        // This is for handing the control form submission.
        if ( $_POST['tipjoy-submit'] ) {
            // Clean up control form submission options
            $newoptions['tip_sidebar_title'] = strip_tags(stripslashes($_POST['tipjoy-title']));
            $newoptions['tipThis_User_ID'] = strip_tags(stripslashes($_POST['tipjoy-ID']));
	        // If original widget options do not match control form
	        // submission options, update them.
	        if ( $options != $newoptions ) {
	            $options = $newoptions;
	            update_option('tipThisAdminOptionsName', $options);
	        }

        }

        // Format options as valid HTML. Hey, why not.
        $title = htmlspecialchars($options['tip_sidebar_title'], ENT_QUOTES);
        $tipjoyID = htmlspecialchars($options['tipThis_User_ID'], ENT_QUOTES);

// The HTML below is the control form for editing options.
?>
        <div>
			<label for="tipjoy-title" style="line-height:35px;display:block;">TipJoy Widget title: <input type="text" id="tipjoy-title" name="tipjoy-title" value="<?php echo $title; ?>" /></label>
			<label for="tipjoy-ID" style="line-height:35px;display:block;">TipJoy ID: <input type="text" id="tipjoy-ID" name="tipjoy-ID" value="<?php echo $tipjoyID; ?>" /></label>
			<input type="hidden" name="tipjoy-submit" id="tipjoy-submit" value="1" />
        </div>
		<?php
	} // end of widget_mywidget_control() 
	
	register_sidebar_widget('TipJoy Badge', 'tipjoy_sidebar_banner');
	register_widget_control('TipJoy Badge', 'tipjoy_sidebar_control');
}
// actions and filters
add_action('activate_TipThis.php','init');
add_action('admin_menu', 'TipThis_ap');
add_action('wp_head', 'addTipJoyHeader');
add_filter('the_content', 'addTipThisButton');
add_action('plugins_loaded', 'tipjoy_sidebar_init');
?>